using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using SpiderMind.Settings;

namespace SpiderMind
{
  public partial class frmConfig : Form
  {
    public frmConfig()
    {
      InitializeComponent();
    }

    private void frmConfig_Load(object sender, EventArgs e)
    {
      cmbSettings.SelectedIndex = Properties.Settings.Default.configActiveSettings;
      cmdApply.Enabled = false;
    }

    private void cmbSettings_SelectedIndexChanged(object sender, EventArgs e)
    {
      Properties.Settings.Default.configActiveSettings = (byte)cmbSettings.SelectedIndex;
      switch (cmbSettings.SelectedIndex)
      {
        case 0:
          gridConfig.SelectedObject = App.Default;
          break;
        case 1:
          gridConfig.SelectedObject = Node.Default;
          break;
        case 2:
          gridConfig.SelectedObject = Throbber.Default;
          break;
        case 3:
          gridConfig.SelectedObject = Workspace.Default;
          break;
      }
    }

    private void button1_Click(object sender, EventArgs e)
    {
      DialogResult myResult;
      myResult = MessageBox.Show(this, "Do you wish to load defaults for just this section?", "Reset Section?", MessageBoxButtons.YesNoCancel, MessageBoxIcon.Asterisk, MessageBoxDefaultButton.Button3);
      if (myResult == DialogResult.Cancel)
        return;
      else if (myResult == DialogResult.No)
      {
        App.Default.Reset();
        Node.Default.Reset();
        Throbber.Default.Reset();
        Workspace.Default.Reset();
      }
      else
      {
        switch (cmbSettings.SelectedIndex)
        {
          case 0:
            App.Default.Reset();
            break;
          case 1:
            Node.Default.Reset();
            break;
          case 2:
            Throbber.Default.Reset();
            break;
          case 3:
            Workspace.Default.Reset();
            break;
        }
      }
      gridConfig.Refresh();
    }

    private void frmConfig_KeyPress(object sender, KeyPressEventArgs e)
    {
      if (e.KeyChar == 0x1b)
        this.DialogResult = DialogResult.Cancel;
    }

    private void cmdApply_Click(object sender, EventArgs e)
    {
      App.Default.Save();
      Node.Default.Save();
      Throbber.Default.Save();
      Workspace.Default.Save();

      cmdApply.Enabled = false;
    }

    private void gridConfig_PropertyValueChanged(object s, PropertyValueChangedEventArgs e)
    {
      cmdApply.Enabled = true;
    }
  }
}